<?php
/*
    nareto_dispo_cron_5min.php

    This file is part of the NaReTo project

    Copyright (C) 2005 Damien Chevalier, Fr�d�ric Reboulet Linagora SA

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

// NaReTo
// script d'agregation des historiques de dispo : CRON 5min
// dchevalier@linagora.com 13-05-2005

include (dirname(__FILE__)."/../include/config.php");


//*******************************************************************************************//
//                              CALCUL & HISTORISATION DES DISPOS
//*******************************************************************************************//

// convertit le tableau dispo (numerateur, denominateur) en pourcentage
function dispo2base($dispo){
	if ($dispo[1]){
		return round(($dispo[0]*1000/$dispo[1]));
	}
	else {
		return -1; 
	}
}

// teste si la boite $id est en downtime
// une boite est en downtime si:
// * c'est un host et il est en downtime
// * toutes les filles sont en downtime
function is_in_downtime($id) {
  $res = mysql_query("select id, poids from boite where parent='".$id."'") or die("marche pas is_in_downtime_1");
  if (mysql_num_rows($res) != 0) {
    // le noeud visit? est une boite
    // on verifie toutes les filles
    while ($row = mysql_fetch_array($res)) {
      if ( is_in_downtime($row["id"]) == false ) {
        // au moins une boite n'est pas en downtime
        // on peut sortir
        return false;
      }
    }
    // si on sort du while, c'est que tous les services sont en downtime
    return ( true );
  }
  else {
    // le noeud visit? est un host (ne contient que des services)
    $res = mysql_query("select * from l_boite_services where id_boite='".$id."' and affiche='1'") or die ("marche pas is_in_downtime_2");
    while ($row = mysql_fetch_array($res)) {
      // au moins un service n'est pas en downtime
      // on peut sortir
      if ( $row["downtime"] == 0 ) {
        return false;
      }
    }
    // si on sort du while, c'est que tous les services sont en downtime
    return true;
  }
}




// teste si la boite $id n'est pas en check_period
// si une boite N'est PAS en check_period alors il NE faut PAS
// calculer sa dispo
// une boite N'est PAS en check_period si:
// * c'est un host et tous les services en dessous NE sont PAS en check_period
// * toutes les filles NE sont PAS en check_period
function is_not_in_check_period($id) {
  $res = mysql_query("select id, poids from boite where parent='".$id."'") or die("marche pas is_not_check_period1");
  if (mysql_num_rows($res) != 0) {
    // le noeud visit? est une boite
    // on verifie toutes les filles
    while ($row = mysql_fetch_array($res)) {
      if ( is_not_in_check_period($row["id"]) == TRUE ) {
        // au moins une boite est check_period
        // on peut sortir
        return TRUE;
      }
    }
    // si on sort du while, c'est que tous les services NE sont PAS en check_period
    return ( FALSE );
  }
  else {
    // le noeud visit? est un host (ne contient que des services)
    $res = mysql_query("select * from l_boite_services where id_boite='".$id."' and affiche='1'") or die ("marche pas is_not_check_period2");
    while ($row = mysql_fetch_array($res)) {
      // au moins un service est en check_period
      // on peut sortir
      if ( $row["not_checked"] == 0 ) {
        return false;
      }
    }
    // si on sort du while, c'est que tous les services sont en check_period
    return true;
  }
}



// fonction de calcul et d'historisation en base mySQL des disponibilit�s
function histo_sql_dispo($choix_boite, $time ) {
	
	global $nom_table;
	$coef_etat = array(1=>1.00,0.50,0.00,0.75,0.00,0.00,0.75,0.00); // coefs applicables aux differents �tats
	$dispo = NULL;
	$dispo_temp = array(0,0); // initialisation de la dispo temporaire destin�e a r�unir  les dispo des fils
	
	$res = mysql_query("select id, poids from boite where parent='".$choix_boite."'") or die("marche pas 1");
	if (mysql_num_rows($res) != 0) { 
		// le noeud visit� est une boite
		while ($row = mysql_fetch_array($res)) {
      $downtime = is_in_downtime($row["id"]); // test si la boite fille est en downtime  
      if ( $downtime ) {
        echo "\nis in downtime: ".$row[id]."\n";
        $dispo_base = 50*10 ;
        $test_exist = mysql_query("select * from ".$nom_table['boite']['report']." where  id='".$row["id"]."'  and dispo='".$dispo_base."'  and time='".$time."' ") or die('echec sql test doublon boite..');
        //si l'entree n'existe pas d?j?
        if (mysql_num_rows($test_exist)== 0) {
          // insertion en base de la dispo locale
          $sql = 'INSERT INTO `'.$nom_table['boite']['report'].'` (`time`, `id`, `dispo`, `agreg`, downtime, not_checked) VALUES ( \''.$time.'\', \''.$row["id"].'\', \''.$dispo_base.'\', \'0\', 1, 0) ';
          echo $sql."\n";
          mysql_query($sql) or die ('echec requete :  enregistrement dispo "boite"');
        }
        next;
      }
			
      if ( is_not_in_check_period($row["id"]) ) { // test si la boite fille est en downtime 
        echo "\nis not in check_period: ".$row[id]."\n";
        $dispo_base = 50*10 ;
        $test_exist = mysql_query("select * from ".$nom_table['boite']['report']." where  id='".$row["id"]."'  and dispo='".$dispo_base."'  and time='".$time."' ") or die('echec sql test doublon boite..');
        //si l'entree n'existe pas d?j?
        if (mysql_num_rows($test_exist)== 0) {
          // insertion en base de la dispo locale
          $sql = 'INSERT INTO `'.$nom_table['boite']['report'].'` (`time`, `id`, `dispo`, `agreg`, downtime, not_checked) VALUES ( \''.$time.'\', \''.$row["id"].'\', \''.$dispo_base.'\', \'0\', 0, 1) ';
          echo $sql."\n";
          mysql_query($sql) or die ('echec requete :  enregistrement dispo "boite"');
        }
        next;
      }   
           
			
			$dispo_fille = histo_sql_dispo($row["id"], $time); //dispo boite fille
			$poids = $row["poids"];

      if ($poids && $dispo_fille[1] ) {
				//on rapporte � 1 le d�nominateur  de la dispo remont�e pour ne pas prendre en compte les ponderations des niveaux inferieurs
				//et on prend en compte  la ponderation du fils actuel
			 	$dispo_fille[0] = $dispo_fille[0]/$dispo_fille[1]*$poids;  
				$dispo_fille[1] = $poids;	
				 // maj de la dispo temp 
				$dispo_temp[0] += $dispo_fille[0];
				$dispo_temp[1] += $dispo_fille[1];
				
				$dispo_base = dispo2base($dispo_fille);
                                echo "poids : $poids, dispo: $dispo_base\n";
				$test_exist = mysql_query("select * from ".$nom_table['boite']['report']." where  id='".$row["id"]."'  and dispo='".$dispo_base."'  and time='".$time."' ") or die('echec sql test doublon boite..');
				//si l'entree n'existe pas d�j�
				if (mysql_num_rows($test_exist)== 0) {
					// insertion en base de la dispo locale 
					$sql = 'INSERT INTO `'.$nom_table['boite']['report'].'` (`time`, `id`, `dispo`, `agreg`) VALUES ( \''.$time.'\', \''.$row["id"].'\', \''.$dispo_base.'\', \'0\') ';
					mysql_query($sql) or die ('echec requete :  enregistrement dispo "boite"');
				} //else echo "doublon boite ".$row["id"]." �vit� <br/>";
				
				
			}
		} 
		
	} else {
		// le noeud visit� est un host (ne contient que des services)
		$res = mysql_query("select * from l_boite_services where id_boite='".$choix_boite."' and affiche='1'") or die ("marche pas 2");
		while ($row = mysql_fetch_array($res)) {
			
			$poids = $row["poids"];
			$etat = $row["etat"];
      $downtime = $row["downtime"];
      $not_checked = $row["not_checked"];
			if($poids) {
        // si le service n'est pas en downtime et que le service est en periode de check
        // on fait le calcul
        if ( ($downtime == 0) && ($not_checked == 0) ) {
          echo "$etat\n";
				$dispo_temp[0] += $poids*$coef_etat[$etat];  
				$dispo_temp[1] += $poids;
				$dispo_serv = array($poids*$coef_etat[$etat],$poids);
				$dispo_base = dispo2base($dispo_serv);
	}
        // sinon, on met une valeur arbitraire
        else {
          $dispo_base = 80*10;
        }
					
				$test_exist = mysql_query("SELECT * FROM ".$nom_table['service']['report']." WHERE  id='".$row["id"]."'  AND dispo='".$dispo_base."'  AND time='".$time."' ") or die('echec sql test doublon service..');
				//si l'entree n'existe pas d�j�
				if (mysql_num_rows($test_exist)== 0) {
					// insertion en base de la dispo locale 
          $sql = 'INSERT INTO `'.$nom_table['service']['report'].'` (`time`, `id`, `dispo`, `agreg`, downtime, not_checked) VALUES (\''.$time.'\', \''.$row["id"].'\', \''.$dispo_base.'\' , \'0\', '.$downtime.', '.$not_checked.' ) ';
	  echo $sql."\n";
					mysql_query($sql) or die ('echec requete :  enregistrement dispo "service"');;
					
				} 			}
		}
	}
	if($dispo_temp[1]) { $dispo = $dispo_temp;} //si au moins un poids n'est pas nul, on met � jour la dispo
	
	return $dispo;	
}


// fixe le temps actuel pour que tous les enregistrements aient le m�me timestamp 
$register_time=time();

//appel � la racine de la fonction recursive
dispo2base(histo_sql_dispo(0, $register_time));




//*******************************************************************************************//
//                                                    AGREGARTION
//*******************************************************************************************//

//*******************************************************************************************//
// stockage des donn�e(5min) dat�es de plus de 2h et non d�j� agreg�es (agreg=0) 

$current_time = time();
$limit_time_recent = $current_time - 2*60*60;  // 2heures

foreach ($nom_table as $type=>$table){
    //select report non agreg� ( agreg = 0)
    $sql = 'SELECT * FROM `'.$table['report'].'` WHERE agreg = 0 AND downtime = 0 AND not_checked = 0 AND time < '.$limit_time_recent.' ';
    $res = mysql_query($sql) or die ('echec requete '.$sql.':  recherche enregistrements historique dispo 5min non agreg�s');
	 
	 if (mysql_num_rows($res) != 0) {
	 	// ajout resultat a agreg_temp_1h
		while ($row = mysql_fetch_array($res)) {
			$sql_insert = 'INSERT INTO `'.$table['agreg1h'].'` (`id`, `time`, `dispo`) VALUES (\''.$row['id'].'\', \''.$row['time'].'\', \''.$row['dispo'].'\')';
      echo $sql_insert."\n";
			mysql_query($sql_insert) or die ('echec requete :  insertion enregistrements agregation "dispo 5min"');          
		}
	}
	// maj agreg = 1
  $sql_update = 'UPDATE `'.$table['report'].'` SET agreg = \'1\', time='.$table['report'].'.time+1 WHERE agreg = 0  AND time < '.$limit_time_recent.' ';
  echo $sql_update."\n";
	mysql_query($sql_update) or die ('echec requete :  mise � jour de l\'etat d\'agregation "dispo 5min" ');
}
 
?>